#include "GameState.h"

// Indicates if the game is currently running within the game loop.
u8 gameRunning = FALSE;

// The score including the progress for the current level.
u16 levelScore = 0;

// Indicates the state of the level (or game) and whether it has ended (including success or failure).
u8 levelState = LEVEL_READY;

// The number of seconds that have elapsed during the level.
u8 levelTimerElapsedSeconds = 0;

// Indicates that the fish timer has elapsed.
u8 fishTimerElapsed = FALSE;

// The current timer count for spawning fish.
u16 fishTimerCount = 0;

// The types of fish that the player has eaten.
u8 fishEaten[MAX_FISH_CAN_EAT];

void resetGameSessionState()
{
    levelState = LEVEL_READY;
    levelScore = 0;
    levelTimerElapsedSeconds = 0;
    fishTimerElapsed = FALSE;
    fishTimerCount = 0;

    // Make sure to reset fish eaten for each session.
    memset(fishEaten, 0, MAX_FISH_CAN_EAT);
}