#ifndef GAMESTATE_H
#define GAMESTATE_H

#include <string.h>
#include "GameTypes.h"

// Indicates if the game is currently running within the game loop.
extern u8 gameRunning;

// The score including the progress for the current level.
extern u16 levelScore;

// Indicates the state of the level (or game) and whether it has ended (including success or failure).
extern u8 levelState;

// Indicates that the time remaining has changed and is to be redrawn on the screen.
extern u8 timeRedraw;

// The number of seconds that have elapsed during the level.
extern u8 levelTimerElapsedSeconds;

// Indicates that the fish timer has elapsed.
extern u8 fishTimerElapsed;

// The current timer count for spawning fish.
extern u16 fishTimerCount;

// The types of fish that the player has eaten.
extern u8 fishEaten[MAX_FISH_CAN_EAT];

// Resets state values for the start of a new game session.
void resetGameSessionState();

#endif