#include "Hud.h"

// X position of the first part of the hud.
#define HUD_X_POSITION_ 0

// Y position of the hud.
#define HUD_Y_POSITION_ 192

// Width of the first part of the hud.
#define HUD_WIDTH_ONE_ 64

// Width of the second part of the hud.
#define HUD_WIDTH_TWO_ 16

// Height of the hud.
#define HUD_HEIGHT_ 8

// X position of the game score.
#define HUD_SCORE_START_ 0

// Width of a hud item.
#define HUD_ITEM_WIDTH_BYTES_ 3

// Width of a thin hud item.
#define HUD_ITEM_THIN_WIDTH_BYTES_ 2

// Width of fish hud item.
#define HUD_FISH_WIDTH_BYTES_ 5

// Hud fish X position.
#define FISH_START_ 27

// Hud fish count x position.
#define FISH_COUNT_START_ 33

// HUD_TIMER_TEXT_START_
#define HUD_TIMER_TEXT_START_ 74

// Indicates if the hud is redrawn on the screen.
u8 hudRedraw = TRUE;

// Indicates that the time remaining has changed and is to be redrawn on the screen.
u8 timeRedraw = TRUE;

void drawHud()
{
    if (hudRedraw)
    {
        static u8 hudText[6];

        // Draw the hud strip on the background.
        al_draw_filled_rectangle(HUD_X_POSITION_, HUD_Y_POSITION_ * scaleFactor, (HUD_WIDTH_ONE_ + HUD_WIDTH_TWO_) * 4 * scaleFactor, (HUD_Y_POSITION_ + HUD_HEIGHT_) * scaleFactor, al_map_rgb(0, 255, 255));

        // Draw the current game score at the bottom left.
        drawScore(levelScore, HUD_SCORE_START_, HUD_Y_POSITION_ * scaleFactor, al_map_rgb(0, 0, 128));

        // Fish eaten count.
        al_draw_scaled_bitmap(allegroHudSprites[0], 0, 0, HUD_FISH_WIDTH_BYTES_ * 2, HUD_HEIGHT_, FISH_START_ * 4 * scaleFactor, HUD_Y_POSITION_ * scaleFactor, HUD_FISH_WIDTH_BYTES_ * 4 * scaleFactor, HUD_HEIGHT_ * scaleFactor, 0);

        convertNumberToString(player.fishEaten, hudText);
        drawString(FISH_COUNT_START_ * 4 * scaleFactor, HUD_Y_POSITION_ * scaleFactor, hudText, al_map_rgb(0, 0, 128));
        drawString((FISH_COUNT_START_ + 2) * 4 * scaleFactor, HUD_Y_POSITION_ * scaleFactor, "/", al_map_rgb(0, 0, 128));

        convertNumberToString(MAX_FISH_CAN_EAT, hudText);
        drawString((FISH_COUNT_START_ + 4) * 4 * scaleFactor, HUD_Y_POSITION_ * scaleFactor, hudText, al_map_rgb(0, 0, 128));

        // The level timer needs to be redrawn as the entire hud has been redrawn.
        timeRedraw = TRUE;

        // Hud will not redraw until hudRedraw is set to true for the next update.
        hudRedraw = FALSE;
    }

    if (timeRedraw)
    {
        // Rectangle underneath the remaining time.
        al_draw_filled_rectangle(HUD_TIMER_TEXT_START_ * 4 * scaleFactor, HUD_Y_POSITION_ * scaleFactor, HUD_TIMER_TEXT_START_ * HUD_ITEM_WIDTH_BYTES_ * 4 * scaleFactor, (HUD_Y_POSITION_ + HUD_HEIGHT_) * scaleFactor, al_map_rgb(0, 255, 255));

        // Draws the remaining time on the right side of the hud.
        drawTimeRemaining(levelTimerElapsedSeconds, HUD_TIMER_TEXT_START_ * 4 * scaleFactor, HUD_Y_POSITION_ * scaleFactor, al_map_rgb(0, 0, 128));

        // We don't want to draw the time continuously.
        timeRedraw = FALSE;
    }
}