#include "Keys.h"

// Player selected controls for movement and actions.
Keys gameControls;

void setDefaultKeys()
{
    gameControls.left = ALLEGRO_KEY_LEFT;
    gameControls.right = ALLEGRO_KEY_RIGHT;
    gameControls.up = ALLEGRO_KEY_UP;
    gameControls.down = ALLEGRO_KEY_DOWN;
    gameControls.exit = ALLEGRO_KEY_ESCAPE;
    gameControls.action = ALLEGRO_KEY_X;
}

void readGameControls(ALLEGRO_EVENT* allegroEvent)
{
    if (allegroEvent->type == ALLEGRO_EVENT_KEY_DOWN)
    {
        if (allegroEvent->keyboard.keycode == gameControls.up)
        {
            gameControls.controlFlags |= CONTROL_UP_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.down)
        {
            gameControls.controlFlags |= CONTROL_DOWN_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.left)
        {
            gameControls.controlFlags |= CONTROL_LEFT_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.right)
        {
            gameControls.controlFlags |= CONTROL_RIGHT_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.action)
        {
            gameControls.controlFlags |= CONTROL_ACTION_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.exit)
        {
            gameControls.controlFlags |= CONTROL_EXIT_FLAG;
        }
    }
    else if (allegroEvent->type == ALLEGRO_EVENT_KEY_UP)
    {
        if (allegroEvent->keyboard.keycode == gameControls.up)
        {
            gameControls.controlFlags &= ~CONTROL_UP_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.down)
        {
            gameControls.controlFlags &= ~CONTROL_DOWN_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.left)
        {
            gameControls.controlFlags &= ~CONTROL_LEFT_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.right)
        {
            gameControls.controlFlags &= ~CONTROL_RIGHT_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.action)
        {
            gameControls.controlFlags &= ~CONTROL_ACTION_FLAG;
        }

        if (allegroEvent->keyboard.keycode == gameControls.exit)
        {
            gameControls.controlFlags &= ~CONTROL_EXIT_FLAG;
        }
    }
    else if (allegroEvent->type == ALLEGRO_EVENT_DISPLAY_CLOSE)
    {
        // Update the exit flag to display the exit dialog on clicking the close button of the window.
        gameControls.controlFlags |= CONTROL_EXIT_FLAG;
    }
}