#ifndef KEYS_H
#define KEYS_H

#include <allegro5/allegro.h>
#include "GameTypes.h"

// Control flag for up key detection.
#define CONTROL_UP_FLAG 1

// Control flag for down key detection.
#define CONTROL_DOWN_FLAG 2

// Control flag for left key detection.
#define CONTROL_LEFT_FLAG 4

// Control flag for right key detection.
#define CONTROL_RIGHT_FLAG 8

// Control flag for action key detection.
#define CONTROL_ACTION_FLAG 16

// Control flag for exit key detection.
#define CONTROL_EXIT_FLAG 64

typedef struct Keys Keys;

// Defines the controls used in the game.
struct Keys
{
    // Key values for setting custom controls.
    unsigned short int up;
    unsigned short int down;
    unsigned short int left;
    unsigned short int right;
    unsigned short int action;
    unsigned short int exit;

    // Flags indicating what controls are down.
    unsigned char controlFlags;
};

// Player selected controls for movement and actions.
extern Keys gameControls;

// Sets the default player controls for the game (if the user does not customise the controls).
void setDefaultKeys();

// Update the controls flags based on the keys that are currently pressed down for Allegro.
void readGameControls(ALLEGRO_EVENT* allegroEvent);

#endif