#ifndef MENU_H
#define MENU_H

#include <allegro5/allegro.h>
#include "Chart.h"
#include "Game.h"
#include "GameTypes.h"
#include "Keys.h"
#include "Text.h"
#include "VersionNo.h"

// Sets up the main menu and runs the menu loop.
void runMenu(u8 fpsCap);

// Draws the main menu on the screen.
void drawMenu();

// Update the controls flags based on the keys that are currently pressed down for Allegro.
unsigned short int getKey(ALLEGRO_EVENT_QUEUE** menuEventQueue);

// Sets up the event queue for allegro to start listening to events in the menu.
void setupMenuEventQueue(ALLEGRO_EVENT_QUEUE** eventQueue);

// Displays the current high scores on the screen in a list.
void displayHighScores(ALLEGRO_EVENT_QUEUE** eventQueue);

// Initialise the high score values.
void initHighScores();

// Displays choices for the user to choose the keyboard/joystick controls for the game.
void rebindControls(ALLEGRO_EVENT_QUEUE** eventQueue);

// Runs the full game session and displays different information based on the outcome.
void runFullGame(ALLEGRO_EVENT_QUEUE** eventQueue, u8 fpsCap);

// Update the high scores if the player has a high score.
void updateHighScores(ALLEGRO_EVENT_QUEUE** eventQueue);

// Allows the user to enter letters to form a word.
void enterWord(u8* word, u8 maxLength, ALLEGRO_EVENT_QUEUE** eventQueue);

#endif