#ifndef TEXT_H
#define TEXT_H

#include <stdio.h>
#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include "GameTypes.h"

// The width of a character from the font when drawing on screen.
#define CHARACTER_WIDTH 2

// The height of a character from the font when drawing on screen.
#define CHARACTER_HEIGHT 8

// The offset used for converting a number to ascii for drawing on screen.
#define ASCII_TO_NUMBER_OFFSET 48

// Draws a string at a specified position on screen using the game font.
void drawString(u16 x, u16 y, const char* string, ALLEGRO_COLOR textColour);

// Initialise fonts used by Allegro.
void initFonts(const char* fontPath);

// Destroy fonts used by Allegro.
void destroyFonts();

// Draws the specified score at the specified position with appropriate zero padding using allegro.
void drawScore(u16 score, u16 x, u16 y, ALLEGRO_COLOR textColour);

// Draw the time remaining in the level at the specified position with appropriate zero padding.
void drawTimeRemaining(u8 time, u16 xPosition, u16 yPosition, ALLEGRO_COLOR textColour);

// Converts a 16 bit number to an equivalent string of characters for printing on screen.
void convertNumberToString(u16 input, u8* output);

#endif